*
**************************************************************************
* Author:       Michael Drozdov
* Description:  The answer to "How we can terminate DE-object on Error"?
* Restrictions: This code (as it's written) means using one database only in DE
*               Hm... and no any free tables :-)
* E-mail:       Mailto:Drozdov@ics.perm.su 
* My Page:      http://vfpdev.narod.ru/
* Date:         06/19/2003
**************************************************************************
*
#DEFINE DATA_SESSION	2		&& Private Data Session
#DEFINE LOCATE_ID 		1049	&& Russian LocateID 
#DEFINE CODE_PAGE 		1251	&& Russian CODEPAGE
#DEFINE SETRUSCOLLATE	.T.		&& USE SET COLLATE TO "RUSSIAN" (TO "MACHINE" otherwise)
*
* ^- Above Russian settings... and need rest to your location
*
#DEFINE SRVUSR_DE_PRG	'' && Because of DE-class is defined here

#DEFINE SEPCONTEXT		'@'
#DEFINE CRLF			CHR(13)+CHR(10)
#DEFINE SEPERRINFO		CRLF

#DEFINE CLS_MYSESSION	'MySe'
#DEFINE CLS_MYDE		'ErrorDE'

#DEFINE USR_DATABASE	HOME(2)+"Data\TestData.dbc"
#DEFINE USR_TABLE		"products1"
*#DEFINE USR_TABLE		"products"

*///////////////////////////////////////////////////////
*// Run-code (main)
*//
SET STEP ON
LOCAL loSe
*
*-- Create my session object 
loSe = NewObject(CLS_MYSESSION)
IF VARTYPE(loSe) # 'O'
	MessageBox("Can not create object '"+CLS_MYSESSION+"'", 16, _SCREEN.Caption)	
	RETURN .F.
ENDIF
*
*-- Try open user data
LOCAL lbOpen
lbOpen = loSe.OpenUsrData(CLS_MYDE)
IF lbOpen
	*
	*-- Now we can use user data
	= MessageBox("Ok!")
ENDIF
RELEASE loSe
RETURN lbOpen
*//
*// The end of Run-code (main)
*///////////////////////////////////////////////////////

*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

*///////////////////////////////////////////////////////
*// My simplest class Session 
*//
DEFINE CLASS MySe AS baseSrvCls && OLEPUBLIC
	name = "MySe"

	FUNCTION OpenUsrData(tcClsDE)
		RETURN This.OpenUserDbc(tcClsDE)
	ENDFUNC	

ENDDEFINE

*///////////////////////////////////////////////////////
*// My simplest class DataEnvironment (with error :-)
*//
DEFINE CLASS ErrorDE AS MyBaseDE
	name = "ErrorDE"
	initialselectedalias = USR_TABLE
	
	ADD OBJECT Cursor1 AS Cursor WITH ;
		name = "Cursor1", ;
		alias = USR_TABLE, ;
		database = USR_DATABASE, ;
		cursorsource = USR_TABLE

ENDDEFINE

*///////////////////////////////////////////////////////
*// My base DataEnvironment class
*//
DEFINE CLASS MyBaseDE AS DataEnvironment

	PROCEDURE Error(nError, cMethod, nLine)
		IF nError = 1
			LOCAL lcExtInfo, lcDatabase
			STORE '' TO ;
				lcExtInfo, lcDatabase
			IF !EMPTY(cMethod)
				LOCAL lnPos
				lnPos = ATC('.', cMethod)
				IF lnPos > 0
					LOCAL loErrObj
					loErrObj = EVALUATE('This'+SUBSTR(cMethod, lnPos))
					IF VARTYPE(loErrObj) = 'O'
						lcExtInfo = " for: '"+loErrObj.CursorSource+"'"
						IF !EMPTY(loErrObj.Database)
							lcDatabase = PROPER(JUSTSTEM(loErrObj.Database))
							lcExtInfo = lcExtInfo + " in database: '"+lcDatabase+"'"
						ENDIF	
					ENDIF	
				ENDIF
			ENDIF
			*////////////////////////////////////////////////////////
			*// In this poit, we try use PRIVATE poSeObj variable
			*// with reference to session object to terminate thread
			IF TYPE('poSeObj') = 'O' AND !ISNULL(poSeObj)
				WITH poSeObj
					IF EMPTY(.cUsrDbcName) AND !EMPTY(lcDatabase)
						*
						*-- Set cUsrDbcName proprty to
						*-- to CLOSE DATABASES in baseSrvCls.CloseDatabase()
						.cUsrDbcName = lcDatabase
					ENDIF	
					.DoError(1098, This.Name+'.Error', LINENO();
						,"File does not exist in "+cMethod+lcExtInfo)
				ENDWITH		
			ELSE
				MessageBox("Message: File does not exist in ";
					+cMethod+lcExtInfo, 16, 'Error in DE')
			ENDIF	
			*////////////////////////////////////////////////////////
		ELSE
			LOCAL ARRAY laErrorArray[7]
			=AERROR(laErrorArray)
			*////////////////////////////////////////////////////////
			*// In this poit, we try use PRIVATE poSeObj variable
			*// with reference to session object to terminate thread
			IF TYPE('poSeObj') = 'O' AND !ISNULL(poSeObj)
				poSeObj.DoError(1098, This.Name+'.Error', LINENO();
					,laErrorArray[2] + " in " + cMethod)
			ELSE
				MessageBox("Message: "+laErrorArray[2]+ " in "+cMethod, 16, 'Error in DE')
			ENDIF	
			*////////////////////////////////////////////////////////
		ENDIF
		*
		*-- On any case in this poit, we need use CANCEL or QUIT
		CANCEL
	ENDPROC	

ENDDEFINE
*//
*// The end of My base DataEnvironment class
*///////////////////////////////////////////////////////

*///////////////////////////////////////////////////////
*// My base Session class
*//
DEFINE CLASS baseSrvCls As Session
	name = "baseSrvCls"
	DataSession = DATA_SESSION
	
	cUsrDbcName = ""			&& User database name	
	oDEusr = NULL				&& Reference to DE for tables from User database
	nDsIDusr = 0				&& DataSessionID for User database

	oMtx = NULL	&& as COMSVCSLib.IMTxAS
	oCtx = NULL && as COMSVCSLib.ObjectContext
	
*	... my other base calss props...
	
	*///////////////////////////////////////////////////
	*// Init event for class
	*//
	PROCEDURE Init
		= SYS(2339, 0) && see Q258736 in MSDN
		IF LOCATE_ID <> 0 
			IF SYS(3004) # LTRIM(STR(LOCATE_ID))
				= SYS(3005, LOCATE_ID)
			ENDIF	
		ENDIF
		WITH This
			IF .DataSession = 1
				.ResetSettings(.T.)
			ENDIF	
		ENDWITH
	ENDPROC

	*///////////////////////////////////////////////////
	*// Destroy event for class
	*//
	PROCEDURE Destroy()
		this.Release()
	ENDPROC

	PROTECTED PROCEDURE Release
		LOCAL lcUsrDbcName, lbNoDEusr
		WITH this
			lcUsrDbcName = .cUsrDbcName
			lbNoDEusr = !EMPTY(lcUsrDbcName)
			.CloseAllData
			.ReleaseAllRefs()
			IF lbNoDEusr
				.CloseDatabase(lcUsrDbcName)
			ENDIF	
		ENDWITH	
	ENDPROC
	
	*///////////////////////////////////////////////////
	*// ReleaseAllRefs
	*//
	PROCEDURE ReleaseAllRefs
		WITH this
			.EndContextObject(.F.)
			.oCtx = NULL
			.oMtx = NULL
		ENDWITH	
	ENDPROC

	*///////////////////////////////////////////////////
	*// CloseAllData  (Is simplified for this example)
	*//
	PROTECTED FUNCTION CloseAllData
		LOCAL lbIsFlush
		*
		*-- CloseUserData
		this.CloseUserData(@lbIsFlush)
		*
		*-- ...
	ENDFUNC

	*///////////////////////////////////////////////////
	*// CloseUserData
	*//
	PROTECTED FUNCTION CloseUserData(tbIsFlush)
		WITH This
			IF VARTYPE(.oDEusr) = 'O'
				IF .DataSession <> 1
					IF .oDEusr.AutoCloseTables
						IF .nDsIDusr <> 0
							SET DATASESSION TO .nDsIDusr
						ENDIF	
						FLUSH
						lbIsFlush = .T.
						.oDEusr.CloseTables()
					ENDIF
				ENDIF	
				.oDEusr = NULL
			ENDIF	
			.cUsrDbcName = ''
			.nDsIDusr = 0
		ENDWITH	
	ENDFUNC		

	PROTECTED FUNCTION CloseDatabase(tcDbcName)
		IF VARTYPE(tcDbcName) # 'C' OR EMPTY(tcDbcName)
			RETURN .F.
		ENDIF	
		IF DBUSED(tcDbcName)
			SET DATABASE TO (tcDbcName)
			CLOSE DATABASES
			SET DATABASE TO
			RETURN .T.
		ENDIF	
		RETURN .F.
	ENDFUNC

	FUNCTION GetCPCurrent()
		RETURN CPCURRENT()
	ENDFUNC

	*///////////////////////////////////////////////////
	*// ResetSettings(tbDefault)
	*//
	PROTECTED FUNCTION ResetSettings(tbDefault)
		IF tbDefault
			SET DATASESSION TO
		ELSE
			SET DATASESSION TO this.DataSessionId
		ENDIF	
		SET TALK OFF
		SET SYSFORMATS ON
		SET DELETED ON
		SET MULTILOCKS ON
		SET EXCLUSIVE OFF
		#IF SETRUSCOLLATE
			IF SET('COLLATE') # "RUSSIAN"
				SET COLLATE TO "RUSSIAN"
			ENDIF	
		#ELSE
			IF SET('COLLATE') # "MACHINE"
				SET COLLATE TO "MACHINE"
			ENDIF	
		#ENDIF	
	ENDFUNC

	*///////////////////////////////////////////////////
	*// GetContextObject (Is simplified for this example)
	*//
	PROTECTED FUNCTION GetContextObject
		WITH this
			.oMtx = NULL
			.oCtx = NULL
		ENDWITH	
	ENDFUNC	

	*///////////////////////////////////////////////////
	*// EndContextObject
	*//
	PROTECTED FUNCTION EndContextObject(tbSuccessful)
		WITH this
			IF VARTYPE(.oCtx) = 'O'
				IF tbSuccessful
					.oCtx.SetComplete()
				ELSE
					.oCtx.SetAbort()
				ENDIF
				.oCtx = NULL
			ENDIF	
		ENDWITH		
	ENDFUNC	

	*///////////////////////////////////////////////////
	*// IsUsrDbc
	*//
	PROTECTED FUNCTION IsUsrDbc
		WITH this
			RETURN (VARTYPE(.oDEusr) = 'O' ;
				AND DBUSED(.cUsrDbcName))
		ENDWITH		
	ENDFUNC
	
	*///////////////////////////////////////////////////
	*// Event Error
	*//
	PROCEDURE Error
		LPARAMETERS nError, cMethod, nLine
		RETURN this.OnError(nError, cMethod, nLine)
	ENDPROC

	*///////////////////////////////////////////////////
	*// DoError
	*// Hm ... we need make as public now :-(
	*// to call it from De.Error(...) event
	PROCEDURE DoError
		LPARAMETERS nError, cMethod, nLine, lcContext
		WITH this	
			IF !EMPTY(lcContext)
				cMethod = cMethod + SEPCONTEXT +lcContext
			ENDIF
			RETURN .OnError(nError, cMethod, nLine)
		ENDWITH	
	ENDPROC	

	*///////////////////////////////////////////////////
	*// OnError (Is simplified for this example)
	*//
	PROTECTED FUNCTION OnError
		LPARAMETERS nError, cMethod, nLine
		*
		*-- Change type args if need
		IF VARTYPE(nError) # 'N'
			nError = 0
		ENDIF
		IF VARTYPE(nLine) # 'N'
			nLine = 0
		ENDIF
		IF VARTYPE(cMethod) # 'C'
			cMethod = ''
		ENDIF
		
		LOCAL lcErrMsg
		lcErrMsg = ''

		*
		*-- Check/Get context from parameter cMethod 
		LOCAL lnPos, lcErrExt
		lnPos = ATC(SEPCONTEXT, cMethod)
		IF lnPos > 0
			lcErrExt = SUBSTRC(cMethod, lnPos+1)
			cMethod = LEFTC(cMethod, lnPos-1)
		ELSE	
			lcErrMsg = MESSAGE()
			IF !EMPTY(lcErrMsg)	
				lcErrMsg = "Message: "+lcErrMsg
			ENDIF	
		ENDIF

		*
		*-- Other standard on error actions
		* ...
		
		IF !EMPTY(nError)
			lcErrMsg = lcErrMsg + SEPERRINFO;
				+ "VFP Error: " + LTRIM(STR(nError))
		ENDIF		
		IF !EMPTY(cMethod)
			lcErrMsg = lcErrMsg + SEPERRINFO;
				+ "Method: " + cMethod
		ENDIF		
		IF !EMPTY(nLine)
			lcErrMsg = lcErrMsg + SEPERRINFO;
				+ "Line: " + LTRIM(STR(nLine))
		ENDIF
		IF !EMPTY(lcErrExt)
			lcErrMsg = lcErrMsg + SEPERRINFO;
				+ "Description: " + lcErrExt
		ENDIF		
		
		*
		*-- Close all databases, SetAbort, Release all refs
		this.Release()
		
		*
		*-- See Q262038
		IF "init" $ LOWER(cMethod)
*        	STRTOFILE(cErrStr, cErrTxtFile, .T.)
*			THIS.xError = cErrStr
		ELSE
			IF !INLIST(Application.StartMode, 0, 4)
				COMRETURNERROR(IIF(!EMPTY(cMethod), cMethod, This.Name+'.Error'), lcErrMsg)
			ELSE
				MessageBox(lcErrMsg, 16, _SCREEN.Caption)
*				RETURN TO MASTER
				CANCEL 
			ENDIF	
		ENDIF

	ENDFUNC	

	*/////////////////////////////////////////////////////////
	*// Create DE object
	*//
	PROTECTED FUNCTION CreateDE(toDE, tcClass, tcModule;
			,tcDbcFile, tcDbcPath, tcFreeTablePath)
		*
		*-- Check type args
		IF VARTYPE(tcClass) # 'C' OR EMPTY(tcClass)
			WITH this
				.DoError(1098, .Name+'.CreateDE', LINENO();
					,"Error type arg: 'tcClass'.")
				RETURN .F.
			ENDWITH	
		ENDIF
		IF VARTYPE(tcModule) # 'C' OR EMPTY(tcModule)
			tcModule = NULL
		ENDIF
		*
		*-- Reset DS settings
		WITH This
			.ResetSettings(IIF(.DataSession <> 1, .F., .T.))
		ENDWITH
		*
		*-- Create DE object
		LOCAL loDE
		loDE = NewObject(tcClass, tcModule)
		IF VARTYPE(loDE) = 'O'
			IF this.ResetDirs(loDE, tcDbcFile, tcDbcPath, tcFreeTablePath)
				*
				*-- Open DE tables
				LOCAL lbIsOpen
				*/////////////////////////////////////////////////
				*// In this poit, we use PRIVATE poSeObj variable
				*// to pass reference of this object to loDE.Error(...) event
				PRIVATE poSeObj
				poSeObj = this
				lbIsOpen = loDE.OpenTables()
				poSeObj = NULL
				IF !lbIsOpen
					RELEASE loDE
					RETURN .F.
				ENDIF
				*/////////////////////////////////////////////////
			ELSE
				RETURN .F.
			ENDIF
		ELSE
			WITH this
				.DoError(1098, .Name+'.CreateDE', LINENO();
					,"Can not create object: '"+tcClass+"'.")
				RETURN .F.
			ENDWITH	
		ENDIF
		*
		*-- Return reference to created DE object
		toDE = loDE
		RETURN .T.
	ENDFUNC

	*/////////////////////////////////////////////////////////
	*// Reset DbcFile, DbcPath and FreeTablePath in DE class
	*// (Is simplified for this example)
	*//
	PROTECTED FUNCTION ResetDirs(toDE, tcDbcFile, tcDbcPath, tcFreeTablePath)
		RETURN .T.
	ENDFUNC

	*///////////////////////////////////////////////////
	*// Create UserDE object for User database
	*// (Is simplified for this example)
	*//
	PROTECTED FUNCTION OpenUserDbc(tcClsDE)
		LOCAL lbRetVal, lbIsClsDE, lbIsFlush
		lbIsClsDE = (VARTYPE(tcClsDE) = 'C' AND !EMPTY(tcClsDE))
		this.CloseUserData(@lbIsFlush)
		IF VARTYPE(this.oDEusr) # 'O'
			LOCAL lbNeedOpenDbc
			lbNeedOpenDbc = .T.
			IF lbIsClsDE
				*
				*-- Create DE object
				WITH this
					LOCAL loDEusr, lcDbcFile, lcDbcPath, lcFreeTablePath
					STORE '' TO ;
						lcDbcFile, lcDbcPath, lcFreeTablePath
					*/////////////////////////////////////////////////////////
					*// Set lcDbcFile, lcDbcPath, lcFreeTablePath if need...
					*// (Usually by use SPM group in COM+)
					*//
					lcDbcFile = USR_DATABASE
					*/////////////////////////////////////////////////////////
					IF .CreateDE(@loDEusr, tcClsDE, SRVUSR_DE_PRG ;
							,lcDbcFile, lcDbcPath, lcFreeTablePath)
						WITH This
							.oDEusr = loDEusr
							IF VARTYPE(.oDEusr) = 'O'	
								.nDsIDusr = SET('DATASESSION')
								IF !EMPTY(lcDbcFile)
									.cUsrDbcName = PROPER(JUSTSTEM(lcDbcFile))
								ENDIF	
								lbRetVal = .T.
							ENDIF
						ENDWITH		
					ELSE
						.DoError(1098, .Name+'.OpenUserDbc', LINENO();
							,"Can not create '"+tcClsDE+"' object.")
						RETURN .F.
					ENDIF
					lbNeedOpenDbc = !DBUSED(.cUsrDbcName)
				ENDWITH	
			ENDIF	
			IF lbNeedOpenDbc
				*
				*-- Open DBC-only (skiped for this example)
				lbRetVal = .F.
			ENDIF
			IF lbRetVal
				SET DATABASE TO (this.cUsrDbcName)
			ENDIF	
		ELSE	
			lbRetVal = .T.	
		ENDIF	
		IF lbIsClsDE AND VARTYPE(this.oDEusr) # 'O'
			lbRetVal = .F.	
		ENDIF
		RETURN lbRetVal
	ENDFUNC

ENDDEFINE
*//
*// The end of My base Session class
*///////////////////////////////////////////////////////
